Index: pykota/trunk/docs/repykota.sgml
===================================================================
--- pykota/trunk/docs/repykota.sgml (revision 959)
+++ pykota/trunk/docs/repykota.sgml (revision 1101)
@@ -11,29 +11,64 @@
   </para>
   
-  <para>
-    PyKota features a quota report generator, named <application>repykota</application>,
-    with which you can print the current state of the quota database.
-  </para>
+  <sect1>
+    <title>Command line based Print Quota reports</title>
+    
+    <para>
+      PyKota features a quota report generator, named <application>repykota</application>,
+      with which you can print the current state of the quota database.
+    </para>
   
-  <para>
-    <application>PyKota</application> also features a CGI script to remotely access
-    to print quota reports with a web browser, it is called <application>printquota.cgi</application>
-    and you can put it in your web server's cgi-bin directory if a web server is installed on
-    any machine on which <application>PyKota</application> is also installed and configured
-    correctly.
-  </para>
-  
-  <sect1>
-    <title><application>repykota</application> commmand line options</title>
-    <para>
-      Here's a decription of each of <application>repykota</application>
-      command line options.
-    </para>
+    <sect2>
+      <title>Reference</title>
+      <para>
+        <cmdsynopsis>
+          <command>repykota</command>
+          <group choice="opt"><arg>-v</arg><arg>--version</arg></group>
+          <group choice="opt"><arg>-h</arg><arg>--help</arg></group>
+          <group choice="opt"><arg>-u</arg><arg>--users</arg></group>
+          <group choice="opt"><arg>-g</arg><arg>--groups</arg></group>
+          <group choice="opt">
+            <arg>-P <replaceable>printername</replaceable></arg>
+            <arg>--printer <replaceable>printername</replaceable></arg>
+          </group>  
+          <group choice="opt">
+            <arg><replaceable>name1</replaceable></arg>
+            <arg><replaceable>name2</replaceable></arg>
+            <arg><replaceable>...</replaceable></arg>
+            <arg><replaceable>nameN</replaceable></arg>
+          </group>  
+        </cmdsynopsis>
+      </para>
+    </sect2>
   </sect1>
   
   <sect1>
-    <title>examples</title>
+    <title>Web based Print Quota reports</title>
+    
     <para>
-      Here are some examples of <application>repykota</application> usage.
+      <application>PyKota</application> also features a CGI script to remotely access
+      to print quota reports with a web browser, it is called <application>printquota.cgi</application>
+      and you can put it in your web server's <filename>cgi-bin</filename> directory if a web server is installed on
+      any machine on which <application>PyKota</application> is also installed and configured
+      correctly.
+    </para>
+    
+    <para>
+      You can find <filename>printquota.cgi</filename> in the <filename>pykota/cgi-bin</filename>
+      directory. Here's how to install it, provided that your web server's <filename>cgi-bin</filename>
+      directory is <filename>/usr/lib/cgi-bin</filename> :
+<screen>      
+port50-2:/home/jerome/pykota$ cp cgi-bin/printquota.cgi /usr/lib/cgi-bin
+port50-2:/home/jerome/pykota$ chmod 755 /usr/lib/cgi-bin/printquota.cgi
+</screen>
+
+      <note>
+        <title>Note</title>
+        <para>
+          Please ensure that the user your web server is run as, for example <literal>www-data</literal> under
+          Debian, is allowed to read <filename>/etc/pykota/pykota.conf</filename> but for security reasons you
+          must ensure that this user <emphasis>is not</emphasis> allowed to read <filename>/etc/pykota/pykotadmin.conf</filename>
+        </para>
+      </note>  
     </para>
   </sect1>
@@ -43,4 +78,7 @@
 
 $Log$
+Revision 1.5  2003/07/25 13:10:58  jalet
+Improved documentation
+
 Revision 1.4  2003/04/24 21:09:47  jalet
 Documentation slightly improved.
Index: pykota/trunk/docs/warnpykota.sgml
===================================================================
--- pykota/trunk/docs/warnpykota.sgml (revision 959)
+++ pykota/trunk/docs/warnpykota.sgml (revision 1101)
@@ -30,27 +30,22 @@
     If you put this command in your <filename>crontab</filename>, launching it for example
     every day, then you'll be sure that all your users who are above their print quota
-    will not forget it !
+    will not forget it ! Of course they may delete the messages without having read them,
+    but at least they won't be able to say that they didn't received them ;-)
   </para>
   
   <para>
-    At the very least, try to make your best to disallow ordinary users to be able to
-    launch this command, since malicious users could fill other users mailboxes
-    by repeatedly running <application>warnpykota</application> : each user above
-    quota would receive multiple email messages, and possibly the administrator too !
+    When a non-root user launches this command, only him can receive a warning
+    message. He can specify a printer name's filter to check his quota only
+    on specific printers. If a non-root users uses the <literal>--groups</literal> command line
+    argument, then for each group he is a member of in the Quota Storage, each
+    group member may receive a warning message. You can take care of this if this
+    becomes annoying by forbidding normal users to launch the <application>warnpykota</application>
+    command.
   </para>
   
-  <sect1>
-    <title>Command line parameters</title>
-    <para>
-      TODO : blah
-    </para>
-  </sect1>
-  
-  <sect1>
-    <title>Examples</title>
-    <para>
-      TODO : blah
-    </para>
-  </sect1>
+  <para>
+    The <literal>root</literal> user can pass additionnal user or group names 
+    (or wildcard filters) to only check the users or groups whose name matches.
+  </para>  
   
   <sect1>
@@ -67,8 +62,11 @@
           <arg>--printer <replaceable>printername</replaceable></arg>
         </group>  
+        <group choice="opt">
+          <arg><replaceable>name1</replaceable></arg>
+          <arg><replaceable>name2</replaceable></arg>
+          <arg><replaceable>...</replaceable></arg>
+          <arg><replaceable>nameN</replaceable></arg>
+        </group>  
       </cmdsynopsis>
-    </para>
-    <para>
-      TODO
     </para>
   </sect1>
@@ -78,4 +76,7 @@
 
 $Log$
+Revision 1.5  2003/07/25 13:10:58  jalet
+Improved documentation
+
 Revision 1.4  2003/04/24 21:09:47  jalet
 Documentation slightly improved.
@@ -90,4 +91,3 @@
 Documentation skeleton added
 
-
 -->
Index: pykota/trunk/docs/pykota.sgml
===================================================================
--- pykota/trunk/docs/pykota.sgml (revision 1099)
+++ pykota/trunk/docs/pykota.sgml (revision 1101)
@@ -16,5 +16,5 @@
   <bookinfo>
     <title>PyKota Documentation</title>
-    <subtitle>A full featured Print Quota Solution for CUPS</subtitle>
+    <subtitle>A full featured Print Quota Solution for CUPS and LPRng</subtitle>
     <copyright>
       <year>2003</year>
@@ -45,5 +45,5 @@
       <para>
         This document will describe the setup of the PyKota Print Quota system
-        for the Common UNIX Printing Environment, and its day-to-day use.
+        for the Common UNIX Printing Environment and LPRng, and its day-to-day use.
       </para>
     </abstract>
@@ -98,4 +98,7 @@
 
 $Log$
+Revision 1.6  2003/07/25 13:10:58  jalet
+Improved documentation
+
 Revision 1.5  2003/07/25 10:41:29  jalet
 Better documentation.
Index: pykota/trunk/docs/pykotme.sgml
===================================================================
--- pykota/trunk/docs/pykotme.sgml (revision 1099)
+++ pykota/trunk/docs/pykotme.sgml (revision 1101)
@@ -63,4 +63,25 @@
     </para>
   </sect1>
+  
+  <sect1>
+    <title>Reference</title>
+    <para>
+      <cmdsynopsis>
+        <command>pykotme</command>
+        <group choice="opt"><arg>-v</arg><arg>--version</arg></group>
+        <group choice="opt"><arg>-h</arg><arg>--help</arg></group>
+        <group choice="opt">
+          <arg>-P <replaceable>printername</replaceable></arg>
+          <arg>--printer <replaceable>printername</replaceable></arg>
+        </group>  
+        <group choice="opt">
+          <arg><replaceable>filename1</replaceable></arg>
+          <arg><replaceable>filename2</replaceable></arg>
+          <arg><replaceable>...</replaceable></arg>
+          <arg><replaceable>filenameN</replaceable></arg>
+        </group>  
+      </cmdsynopsis>
+    </para>
+  </sect1>
 </chapter>
 
@@ -68,4 +89,7 @@
 
 $Log$
+Revision 1.2  2003/07/25 13:10:58  jalet
+Improved documentation
+
 Revision 1.1  2003/07/25 10:41:30  jalet
 Better documentation.
Index: pykota/trunk/docs/filterpykota.sgml
===================================================================
--- pykota/trunk/docs/filterpykota.sgml (revision 1099)
+++ pykota/trunk/docs/filterpykota.sgml (revision 1101)
@@ -7,5 +7,12 @@
   
   <para>
-    To account for pages or eventually ink usage, you must plug your accounting
+    To account for pages or eventually ink usage 
+    <footnote>
+      <para>
+        PyKota doesn't currently account for ink usage, it only accounts
+        pages. To account for ink usage, you should use PrintBill instead.
+      </para>  
+    </footnote>  
+    , you must plug your accounting
     system somewhere into the printing system you use, be it either <application>CUPS</application>
     or <application>LPRng</application>. One way to do this without having
@@ -54,6 +61,6 @@
     When used with an <application>LPRng</application> backend, the accounting filter is not defined the same way 
     input filters are, so the problem described above doesn't exist, and <application>PyKota</application>
-    may work with non-postscript printers, provided they can report their page counter and you know how to do
-    this.
+    may work with non-postscript printers, provided they can report their page counter and you know how to retrieve
+    it.
   </para>
   
@@ -71,5 +78,5 @@
     page counter for this printer when the previous job was launched, computes the difference, and report it as the 
     previous job's size in the Quota DataBase. It then updates the last user's print quota and account balance, and
-    warn him if he is over quota or his account balance below 0. Finally it checks if the user who launched the 
+    warn him if he is over quota or if his account balance is below 0. Finally it checks if the user who launched the 
     current job is below or above his print quota, and either allow or deny the job's datas to pass to the underlying 
     layer (the printer itself).
@@ -83,4 +90,6 @@
     pages on a single line on its standard output. This number is then
     read by PyKota and used to update the current user's quota information.
+    Of course checks are also done like with the <literal>querying</literal>
+    accounting method, to see if the current job is allowed to be printed or not.
   </para>
   
@@ -97,4 +106,7 @@
 
 $Log$
+Revision 1.6  2003/07/25 13:10:58  jalet
+Improved documentation
+
 Revision 1.5  2003/07/25 10:41:29  jalet
 Better documentation.